

#include "74ls595.h"
#include "main.h"


//------| Led array output functions |------



void LS595_Init(parallel_t * pp) {
  LS595_PP = pp;
}

void CD4094_Set8(unsigned int bits) { // <- use this one
  StrobeL();
  LS595_SendByte(bits);
  StrobeH();
}

void LS595_Set8(unsigned int bits) { // <- use this one
  StrobeH();
  LS595_SendByte(bits);
  StrobeL();
}

void CD4094_Set16(unsigned int bits) { // <- use this one
  StrobeL();
  LS595_SendByte(bits>>8);
  LS595_SendByte(bits);
  StrobeH();
}

void LS595_Set16(unsigned int bits) { // <- use this one
  StrobeH();
  LS595_SendByte(bits>>8);
  LS595_SendByte(bits);
  StrobeL();
}

void CD4094_SetArray(unsigned int bytes, char * data) { // <- use this one

  unsigned int i;
  LS595_DEBUG("setting strobe low\n");
  StrobeL();
  LS595_DEBUG("starting byte loop\n");
  for (i = bytes; i != 0; i--) {
    LS595_DEBUG("sending byte\n");
    LS595_SendByte(data[i-1]);
  }  
  StrobeH();
}

void LS595_SetArray(unsigned int bytes, char * data) { // <- use this one

  unsigned int i;

  StrobeH();
  for (i = bytes; i != 0; i--) {
    LS595_SendByte(data[i-1]);
  }  
  StrobeL();
}

// MSB first
void LS595_SendByte (unsigned int bits) {
  unsigned int temp;  
  for( temp = 128; temp != 0; temp = temp >> 1) {    
    if ( (bits & temp) != 0 ) {
      SendOne();
    } else {
      SendZero();
    }    
  } 
}

