#ifndef _74ls595_H
  #define _74ls595_H
  
//  #define DEBUG_LS595

#ifdef DEBUG_LS595
  #include <stdio.h>
  #define LS595_DEBUG(A)  printf(A)
#else
  #define LS595_DEBUG(A)  /* (A) */
#endif
  
  #include "parallel.h"
  
    parallel_t * LS595_PP;
  
    // Bit positions
  #define Strobe                   UNIPPORT_D1
  #define Data                     UNIPPORT_D2
  #define Clock                    UNIPPORT_D0

  #define StrobeH()                SetBit  (Strobe, port); NOP()
  #define StrobeL()                ClearBit(Strobe, port); NOP()
  #define DataH()                  SetBit  (Data,   port)
  #define DataL()                  ClearBit(Data,   port)
  #define SetData(B)               DefBit  (Data,   port, B)
  #define ClockH()                 SetBit  (Clock,  port)
  #define ClockL()                 ClearBit(Clock,  port)
  #define ClockPulse()             ClockH(); NOP(); ClockL(); NOP()
  #define SendOne()                DataH(); ClockPulse()
  #define SendZero()               DataL(); ClockPulse()

  
  #define SetBit(BIT, PORT)           parallel_WriteBit(LS595_PP, BIT, 1)
  #define ClearBit(BIT, PORT)         parallel_WriteBit(LS595_PP, BIT, 0)
  #define DefBit(BIT, PORT, VALUE)    parallel_WriteBit(LS595_PP, BIT, VALUE)
  #define IsHigh(BIT, PORT)           (parallel_ReadBit(LS595_PP, BIT)==1)
  #define IsLow(BIT, PORT)            (parallel_ReadBit(LS595_PP, BIT)==0)

  
  void LS595_Init(parallel_t * pp);
  void CD4094_Set8   (unsigned int bits);
  void LS595_Set8  (unsigned int bits);
  void CD4094_Set16   (unsigned int bits);
  void LS595_Set16  (unsigned int bits);  
  void LS595_SendByte (unsigned int bits);
  void CD4094_SetArray(unsigned int bytes, char * data);
  void LS595_SetArray(unsigned int bytes, char * data);


   
/*
  #define SetBit(BIT, PORT)        PORT |= (1<<BIT)
  #define ClearBit(BIT, PORT)      PORT &= ~(1<<BIT)
  #define DefBit(BIT, PORT, VALUE) PORT &= (~(1<<BIT))|((VALUE==0?0:1)<<BIT)
  #define IsHigh(BIT, PORT)       (PORT & (1<<BIT)) != 0
  #define IsLow(BIT, PORT)        (PORT & (1<<BIT)) == 0
*/

  
  
    #define NOP()     /**/
//      #define NOP()                    usleep(1)
//    #define NOP()                    microdelay(10)



#endif
